<?php

use Core\Bootstrap;
use Core\Env\Env;
use Core\Http\Request;


if(!function_exists('app'))
{
    /**
     * Make abstract of instance or get application instance
     *
     * @param mixed $abstract
     * @param array $arguments
     * @return \Core\Factory\BootstrapFactory|mixed
     */
    function app(mixed $abstract = null, array $arguments = []): mixed
    {
        if (is_null($abstract)) {
            return Bootstrap::getInstance();
        }

        return Bootstrap::getInstance()->make($abstract, $arguments);
    }
}

if(!function_exists('env'))
{
    /**
     * Get env variable
     *
     * @param string $key
     * @return bool
     */
    function env(string $key): mixed
    {
        return Env::get($key);
    }
}

if (!function_exists('request')) {
    /**
     * Get the request instance
     *
     * @return \Core\Http\Request
     */
    function request(): Request
    {
        return app()->request();
    }
}
